MODULE PosixCsys_stat ['sys/stat.h'];

  (* generated by genposix.sh, do not modify *)

  IMPORT SYSTEM, PosixCtypes, PosixCtime, PosixCsys_types;

  TYPE
    char* = PosixCtypes.char;
    signed_char* = PosixCtypes.signed_char;
    unsigned_char* = PosixCtypes.unsigned_char;
    short* = PosixCtypes.short;
    short_int* = PosixCtypes.short_int;
    signed_short* = PosixCtypes.signed_short;
    signed_short_int* = PosixCtypes.signed_short_int;
    unsigned_short* = PosixCtypes.unsigned_short;
    unsigned_short_int* = PosixCtypes.unsigned_short_int;
    int* = PosixCtypes.int;
    signed* = PosixCtypes.signed;
    signed_int* = PosixCtypes.signed_int;
    unsigned* = PosixCtypes.unsigned;
    unsigned_int* = PosixCtypes.unsigned_int;
    long* = PosixCtypes.long;
    long_int* = PosixCtypes.long_int;
    signed_long* = PosixCtypes.signed_long;
    signed_long_int* = PosixCtypes.signed_long_int;
    unsigned_long* = PosixCtypes.unsigned_long;
    unsigned_long_int* = PosixCtypes.unsigned_long_int;
    long_long* = PosixCtypes.long_long;
    long_long_int* = PosixCtypes.long_long_int;
    signed_long_long* = PosixCtypes.signed_long_long;
    signed_long_long_int* = PosixCtypes.signed_long_long_int;
    unsigned_long_long* = PosixCtypes.unsigned_long_long;
    unsigned_long_long_int* = PosixCtypes.unsigned_long_long_int;
    float* = PosixCtypes.float;
    double* = PosixCtypes.double;
    long_double* = PosixCtypes.long_double;

  CONST
    S_IFMT* = 61440;
    S_IFBLK* = 24576;
    S_IFCHR* = 8192;
    S_IFIFO* = 4096;
    S_IFREG* = 32768;
    S_IFDIR* = 16384;
    S_IFLNK* = 40960;
    S_IFSOCK* = 49152;

  CONST
    S_IRWXU* = 448;
    S_IRUSR* = 256;
    S_IWUSR* = 128;
    S_IXUSR* = 64;
    S_IRWXG* = 56;
    S_IRGRP* = 32;
    S_IWGRP* = 16;
    S_IXGRP* = 8;
    S_IRWXO* = 7;
    S_IROTH* = 4;
    S_IWOTH* = 2;
    S_IXOTH* = 1;
    S_ISUID* = 2048;
    S_ISGID* = 1024;
    S_ISVTX* = 512;

  CONST
    UTIME_NOW* = 1073741823;
    UTIME_OMIT* = 1073741822;

  TYPE
    blkcnt_t* = PosixCsys_types.blkcnt_t;
    blksize_t* = PosixCsys_types.blksize_t;
    dev_t* = PosixCsys_types.dev_t;
    ino_t* = PosixCsys_types.ino_t;
    mode_t* = PosixCsys_types.mode_t;
    nlink_t* = PosixCsys_types.nlink_t;
    uid_t* = PosixCsys_types.uid_t;
    gid_t* = PosixCsys_types.gid_t;
    off_t* = PosixCsys_types.off_t;
    time_t* = PosixCsys_types.time_t;

  TYPE
    struct_timespec* = PosixCtime.struct_timespec;

  TYPE
    Pstruct_stat* = POINTER TO struct_stat;
    struct_stat* ['struct stat'] = RECORD [noalign] (* 88 *)
      st_dev*: dev_t; (* 0+8 *)
      st_ino*: ino_t; (* 12+4 *)
      st_mode*: mode_t; (* 16+4 *)
      st_nlink*: nlink_t; (* 20+4 *)
      st_uid*: uid_t; (* 24+4 *)
      st_gid*: gid_t; (* 28+4 *)
      st_rdev*: dev_t; (* 32+8 *)
      st_size*: off_t; (* 44+4 *)
      st_blksize*: blksize_t; (* 48+4 *)
      st_blocks*: blkcnt_t; (* 52+4 *)
      st_atim*: struct_timespec; (* 56+8 *)
      st_mtim*: struct_timespec; (* 64+8 *)
      st_ctim*: struct_timespec; (* 72+8 *)
    END;

  PROCEDURE [ccall] chmod* (IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t): int;
  PROCEDURE [ccall] fchmod* (fd: int; IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t): int;
  PROCEDURE [ccall] fchmodat* (fd: int; IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t; flag: int): int;
  PROCEDURE [ccall] fstat* (fd: int; VAR buf: struct_stat): int;
  PROCEDURE [ccall] fstatat* (fd: int; IN path: ARRAY [untagged] OF SHORTCHAR; VAR buf: struct_stat; flag: int): int;
  PROCEDURE [ccall] futimens* (fd: int; IN times: ARRAY [untagged] 2 OF struct_timespec): int;
  PROCEDURE [ccall] lstat* (IN path: ARRAY [untagged] OF SHORTCHAR; VAR buf: struct_stat): int;
  PROCEDURE [ccall] mkdir* (IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t): int;
  PROCEDURE [ccall] mkdirat* (fd: int; IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t): int;
  PROCEDURE [ccall] mkfifo* (IN pathname: ARRAY [untagged] OF SHORTCHAR; mode: mode_t): int;
  PROCEDURE [ccall] mkfifoat* (dirfd: int; IN pathname: ARRAY [untagged] OF SHORTCHAR; mode: mode_t): int;
  PROCEDURE [ccall] mknod* (IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t; dev: dev_t): int;
  PROCEDURE [ccall] mknodat* (df: int; IN path: ARRAY [untagged] OF SHORTCHAR; mode: mode_t; dev: dev_t): int;
  PROCEDURE [ccall] stat* (IN path: ARRAY [untagged] OF SHORTCHAR; VAR buf: struct_stat): int;
  PROCEDURE [ccall] umask* (mode: mode_t): mode_t;
  PROCEDURE [ccall] utimensat* (dirfd: int; IN pathname: ARRAY [untagged] OF SHORTCHAR; IN times: ARRAY [untagged] 2 OF struct_timespec; flags: int): int;

END PosixCsys_stat.
